#ifndef parse_utils
#define parse_utils

#include <yaml-cpp/yaml.h>
#include <string>
#include <algorithm>
#include <exception>


inline bool ends_with(std::string const & value, std::string const & ending)
{
    if (ending.size() > value.size()) return false;
    return std::equal(ending.rbegin(), ending.rend(), value.rbegin());
}

inline uint32_t to_seconds_duration(YAML::Node duration_node)
{
        if(!duration_node.IsScalar()) throw std::invalid_argument("node is not a time duration");

	const auto duration_str = duration_node.as<std::string>();

	if(ends_with(duration_str,"seconds"))
		return atoi(duration_str.c_str()) * 1;
	if(ends_with(duration_str,"minutes"))
		return atoi(duration_str.c_str()) * 60;
	if(ends_with(duration_str,"hours"))
		return atoi(duration_str.c_str()) * 60 * 60;

	throw std::invalid_argument("Cannot convert " + duration_str + " to duration");

}

#endif
