
#ifndef afl_fuzz_hpp
#define afl_fuzz_hpp

#include "fuzz-base.hpp"
#include <set>

namespace Turbo
{
	using namespace std;

	class AflFuzz_t : public FuzzBase_t
	{

		public:
			// yeah, but please don't call this.
			AflFuzz_t(const YAML::Node& _fuzz_config, const YAML::Node& _app_config, const OptionVector_t& _options, const int32_t _ver_id)
			       : FuzzBase_t(_options, _ver_id) ,
			       fuzz_config(_fuzz_config),
			       app_config(_app_config)
			{
			}
			virtual ~AflFuzz_t(){}

			virtual int32_t execute() override;
			virtual int32_t getAllInputs() override; 


		private:

			virtual void cleanWorkdir() final;
			virtual void doAfl()        final;
			virtual void writeInputs () final;
			virtual string getAflCmd()  final;
			virtual void handleAflGeneratedInputs() final;
			virtual void uploadCrashes(const string&) final;
			virtual int32_t uploadInput(const string& path) final;


			virtual std::set<string> generateCmdLines() const final;

			const YAML::Node& fuzz_config;
		       	const YAML::Node& app_config;

			using FlatFile_t  = string;
			using FlatInput_t = vector<FlatFile_t>;
			set<FlatInput_t>          flat_inputs;
			map<FlatInput_t,uint32_t> flat_input_to_id_map;

	};

}

#endif
